use <wineglass.scad>;
a = 40;
b = a;
r = a/12;
gb = a/6;
$fn = 50;
sc = 0.0018;
module szescian(a,b){
    linear_extrude(b-b/5)
    hull(){
    translate([-a/2+r,-a/2+r,-a/2+r])
    circle(r);
    translate([a/2-r,-a/2+r,-a/2+r])
    circle(r);  
    translate([-a/2+r,a/2-r,-a/2+r])
    circle(r);
    translate([a/2-r,a/2-r,-a/2+r])
    circle(r);
    } 
}
module obudowa(){
    
    color("CornflowerBlue")
    difference(){
        difference(){
        szescian(a,b);
        translate([0,0,-5])
        szescian(a-gb,b+10);
        }
    translate([-b/2,-0.1+b/5,b/2-b/5+b/20-0.1])
    cube([b,b/20+0.2,b/10+0.2]);
    }

}
module dziura_w_obudowie(){
        color("CornflowerBlue")
    difference(){
        union(){
        obudowa();
        }
        union(){
            translate([a/2-gb/6,0,a/2-a/10])
            cube([gb/3+0.1,a-a/5,a-a/5+0.1],true);
            translate([-a/2+gb/6,0,a/2-a/10])
            cube([gb/3+0.1,a-a/5,a-a/5+0.1],true);            
            translate([0,a/2-gb/6,a/2-a/10])
            cube([a-a/5,gb/3+0.1,a-a/5+0.1],true);
            translate([0,-a/2+gb/6,a/2-a/10])
            cube([a-a/5,gb/3+0.1,a-a/5+0.1],true);            translate([0,0,-a/2])
            translate([0,0,-a/10+gb/6-0.1])
            cube([a-a/5,a-a/5,gb/3+0.1],true);
            translate([0,0,a-a/10-gb/6+0.1])
            cube([a-a/5,a-a/5,gb/3+0.1],true);             
            translate([a/2-2.5,a/2-2.5,-0.01])
            cylinder(2,1,1);
            translate([-a/2+2.5,a/2-2.5,-0.01])
            cylinder(2,1,1);
            translate([a/2-2.5,-a/2+2.5,-0.01])
            cylinder(2,1,1);
            translate([-a/2+2.5,-a/2+2.5,-0.01])
            cylinder(2,1,1);
        }    
    }
    translate([a/2-2.5,a/2-2.5,a-a/5])
    cylinder(2,1,1);
    translate([-a/2+2.5,a/2-2.5,a-a/5])
    cylinder(2,1,1);
    translate([a/2-2.5,-a/2+2.5,a-a/5])
    cylinder(2,1,1);
    translate([-a/2+2.5,-a/2+2.5,a-a/5])
    cylinder(2,1,1);
}
module podstawka(){
    color("CornflowerBlue")
    translate([b/6,-b/2+gb/2,b/20])
    cube([b/10,b/25,b-b/5-b/10]);   
    color("CornflowerBlue")
    translate([-b/6-b/10,-b/2+gb/2,b/20])
    cube([b/10,b/25,b-b/5-b/10]);  
    color("grey")
    translate([0,0,b/40])
    difference(){
    linear_extrude(b-b/5-b/20)
    hull(){
        translate([b/2-gb/2-b/20-b/60,-b/2+gb/2+b/20+b/25,0])
        circle(b/20);  
        translate([-b/2+gb/2+b/20+b/60,-b/2+gb/2+b/20+b/25,0])
        circle(b/20);
    }  
    translate([-b/2-1,-b/2+gb/2+b/20+b/25,-1])
    cube([b-1,b,b]);
    }
}
module mocowanie_glowica(b){
    color("LightGrey")
    translate([-b/2+gb/3,b/5+0.1,b/2-b/5+b/20+0.1])
    cube([b-gb/3-gb/3,b/20-0.2,b/10-0.2]);
    
}

module glowica(){
    color("dimgrey")
    translate([0,b/5,0])
    difference(){
        hull(){
            translate([b/8,0,(b-b/5)/2-b/10])
            rotate([90,0,180])
            linear_extrude(0.1)
            square([b/4,b/5]);
            translate([b/8,-b/10,(b-b/10)/2-b/10])
            rotate([90,0,180])
            linear_extrude(0.1)
            square([b/4,b/10]);
        }
        union(){
            translate([0,b/20-b/10,0])
            hull(){
                rotate([90,90,0])
                cylinder(b/20,b/20,0,$fn=4);
                translate([0,0,b])
                rotate([90,90,0])
                cylinder(b/20,b/20,0,$fn=4);
            }
            translate([-b/20,b/20-b/10-0.1,0])
            cube([b/10,b/10,b]);
        }
    }
    color("dimgrey")
    translate([-b/8,b/5,b/2-b/20])
    cube([b/4,b/20,b/20]);
    color("dimgrey")
    translate([-b/8,b/5,b/2-b/4+b/20])
    cube([b/4,b/20,b/20]);
    color("dimgrey")
    hull(){
        translate([b/8,b/10,(b-b/10)/2-b/10]){
        rotate([90,0,180])
        linear_extrude(0.1)
        square([b/4,b/10]);    
        translate([-b/100,-b/40,b/100])
        rotate([90,0,180])
        linear_extrude(0.1)
        square([b/4-b/50,b/10-b/50]);
        }
    }
    color("dimgrey")
    translate([b/8,b/10,(b-b/10)/2-b/10])
    hull(){
        translate([-b/100,-b/40,b/100])
        rotate([90,0,180])
        linear_extrude(0.1)
        square([b/4-b/50,b/10-b/50]);
        translate([-b/100-b/100,-b/40-b/20,b/100+b/50])
        rotate([90,0,180])
        linear_extrude(0.1)
        square([b/4-b/50-b/50,b/10-b/50-b/25]);
    }
    color("dimgrey")
    translate([-b/9.5,-b/70,b/2-b/8+b/200])
    cube([b/4-b/50-b/50,b/10-b/50-b/25,b/10-b/50-b/25]);
    color("dimgrey")
    translate([0,-b/70,b/2-b/10])
    resize(newsize=[b/4-b/50-b/50,b/10-b/50-b/25,b/10/2-b/100])
    rotate([90,45,0])
    cylinder(b/10-b/50-b/25,b/10-b/50-b/25,0, $fn = 4);
    color("dimgrey")
    difference(){
        translate([-b/8,b/5+b/20,b/2-b/5])
        cube([b/4,b/20,b/5]);
        translate([-b/8-0.5,b/5+b/20-0.5,b/2-b/20-b/10])
        cube([b/4+1,b/40+0.5,b/10]);
    }
}
module wino(){
    
    translate([b/15,-b/2+gb/2+b/20+b/25,b/2-b/10])
    scale([b*sc,b*sc,b*sc])
    rotate([270,0,0])
    color("skyblue")
    wineglass();
    translate([2.65,-a/4+2,a/2-4])
    rotate([90,90,0])
    cylinder(4.8,0.9,0.9);
    
}

module scianki(){
    translate([0,0,a/15-r])
    hull(){
        difference(){
            hull(){   
                translate([-a/2+r,-a/2+r,0])
                sphere(r, $fa=50);
                translate([a/2-r,-a/2+r,0])
                sphere(r, $fa=50);  
                translate([-a/2+r,a/2-r,0])
                sphere(r, $fa=50);
                translate([a/2-r,a/2-r,0])
                sphere(r, $fa=50);
                
            }
            translate([0,0,-a/20+r])
            cube([a,a,a/10],true);
        }
        translate([0,0,0])
        linear_extrude(a/10-r)
        hull(){
        translate([-a/2+r,-a/2+r,0])
        circle(r);
        translate([a/2-r,-a/2+r,0])
        circle(r);  
        translate([-a/2+r,a/2-r,0])
        circle(r);
        translate([a/2-r,a/2-r,0])
        circle(r);
        } 
    }
}

module fidget_1(){
    color("CornflowerBlue")
    difference(){
        translate([a/2-gb/6+gb*2,-0.1,a/2-a/10-0.1])
        rotate([0,0,90])
        cube([a-a/5,gb/3-0.2,a-a/5-0.2],true);
        union(){
            translate([a/2-gb/6-gb/9+gb*2,0,a/2-a/10])
            rotate([0,0,90])
            cube([a-a/5-a/10,gb/9,a-a/5-a/10],true);
            translate([a/2-gb/6-gb/9+gb*2,-a/4-a/20,a/20+a/20])
            cube([a/10,a/20,a-a/5-a/10-a/10]); 
            translate([a/2-gb/6-gb/9+gb*2,0,a/20+a/20])
            rotate([90,0,0])
            cube([a/10,a/20,(a-a/5-a/10-a/10-a/10)/2+1]);
            translate([a/2-gb/6-gb/9+gb*2,-a/20,a/20+a/20])
            cube([a/10,a/20,a-a/5-a/10-a/10]);
            translate([a/2-gb/6-gb/9+gb*2,a/5+a/20,a-a/5-a/10-a/20])
            rotate([90,0,0])
            cube([a/10,a/20,(a-a/5-a/10-a/10-a/10)/2+1]);        translate([a/2-gb/6-gb/9+gb*2,a/4-a/20,a/20+a/20])
            cube([a/10,a/20,a-a/5-a/10-a/10]);            
        }
    }
    color("grey")
    translate([a/2-gb/6-gb/9+gb*2+a/80,-a/20,a/10])
    rotate([0,90,0])
    cylinder(a/10,a/40-0.2,a/40-0.2);
    color("grey")
    translate([a/2-gb/6-gb/9+gb*2+a/80-a/40+gb/18+0.2,-a/20-a/40+a/40,a/10-a/40+a/40])
    rotate([0,90,0])
    cylinder(gb/9-0.2,a/20-0.2,a/20-0.2);
}

module fidget_2(){
    color("CornflowerBlue")
    difference(){
        translate([0,0,gb*2])
        union(){ 
            translate([0,0,a-a/10-gb/6])
            rotate([90,0,0])
            cube([a-a/5,gb/3,a-a/5],true);
            difference(){
                translate([0,0,a-a/5])
                rotate([180,0,0])
                difference(){
                    scianki();
                    union(){
                        translate([a/2-2.5,a/2-2.5,a/4-gb*2+1.34])
                        cylinder(2,1,1);
                        translate([-a/2+2.5,a/2-2.5,a/4-gb*2+1.34])
                        cylinder(2,1,1);
                        translate([a/2-2.5,-a/2+2.5,a/4-gb*2+1.34])
                        cylinder(2,1,1);
                        translate([-a/2+2.5,-a/2+2.5,a/4-gb*2+1.34])
                        cylinder(2,1,1);            
                    }
                    }
            }
        }
        union(){
            translate([-0.1,-0.1,a-a/10-gb/6+gb*2])
            cube([6+0.2,6+0.2,6],true);
            translate([a/4-0.1,a/4-0.1,a-a/10-gb/6+gb*2])
            cube([6+0.2,6+0.2,6],true);
            translate([a/4-0.1,-a/4-0.1,a-a/10-gb/6+gb*2])
            cube([6+0.2,6+0.2,6],true);
            translate([-a/4-0.1,a/4-0.1,a-a/10-gb/6+gb*2])
            cube([6+0.2,6+0.2,6],true);
            translate([-a/4-0.1,-a/4-0.1,a-a/10-gb/6+gb*2])
            cube([6+0.2,6+0.2,6],true);
        }
    } 
    color("grey")
    translate([-0.1,-0.1,a-a/10+gb*2+20]){
        difference(){
            cylinder(3,8.485/2-0.05,8.485/2-0.05);
            translate([0,0,-0.1])
            cylinder(1,3.7/2,3.7/2);
        }
    }    color("CornflowerBlue")
    translate([-0.1,-0.1,a-a/10+gb*2]){
        difference(){
            cylinder(0.5,5+1,1+8.485/2+0.1);
            translate([0,0,-0.1])
            cylinder(3,8.485/2+0.1,8.485/2+0.1);
        }
    }    color("CornflowerBlue")
    translate([-0.1+a/4,-0.1+a/4,a-a/10+gb*2]){
        difference(){
            cylinder(0.5,5+1,8.485/2+0.1+1);
            translate([0,0,-0.1])
            cylinder(3,8.485/2+0.1,8.485/2+0.1);
        }
    }    color("CornflowerBlue")
    translate([-0.1+a/4,-0.1-a/4,a-a/10+gb*2]){
        difference(){
            cylinder(0.5,5+1,8.485/2+0.1+1);
            translate([0,0,-0.1])
            cylinder(3,8.485/2+0.1,8.485/2+0.1);
        }
    }    color("CornflowerBlue")
    translate([-0.1-a/4,-0.1+a/4,a-a/10+gb*2]){
        difference(){
            cylinder(0.5,5+1,8.485/2+0.1+1);
            translate([0,0,-0.1])
            cylinder(3,8.485/2+0.1,8.485/2+0.1);
        }
    }    color("CornflowerBlue")
    translate([-0.1-a/4,-0.1-a/4,a-a/10+gb*2]){
        difference(){
            cylinder(0.5,5+1,1+8.485/2+0.1);
            translate([0,0,-0.1])
            cylinder(3,8.485/2+0.1,8.485/2+0.1);
        }
    }
}
module fidget_3(){
    
    
    color("CornflowerBlue")
    translate([0,gb*3,0])
    difference(){
    translate([0,a/2-gb/6-0.05,a/2-a/10-0.05])
    difference(){
        cube([a-a/5-0.1,gb/3-0.1,a-a/5-0.1],true);  
    }
   
    translate([0,a/4+a/4,a/2-4])
    rotate([90,90,0])
    cylinder(4,5.15,5.15);
    }
    translate([0,gb*3,0])
    %translate([0,a/2-gb/6-0.05+3,a/2-4])
    rotate([90,90,0])
    difference(){
    cylinder(4,5,5);
        translate([0,0,-0.05])
    cylinder(4.1,2.5,2.5);

    }   color("grey")
    translate([0,gb*3,0])
        import("testt.stl",conexivity=1000);
       

}

module fidget_4(){
    translate([0,-gb*3,0])
    difference(){
        translate([0,-a/2+gb/6+0.05,a/2-a/10-0.05])
        cube([a-a/5-0.1,gb/3-0.1,a-a/5-0.1],true);
        scale([0.45,0.45,0.45])
        translate([a/2+a/4+a/8,-a-3,a*5])
        rotate([90,45,0])
        linear_extrude(3)
        import("reprapypl5.dxf", convexity=3);  
    }
    
}
module fidget_5(){
            color("CornflowerBlue")
    translate([0,0,-a/2])
    difference(){
    scianki(); 
        union(){
            translate([0,0,gb/4-a/10-0.4])
            cube([a/2+a/5+0.4,gb*2+0.4,gb/2.5+0.4],true);
            translate([0,a/4,-gb/2])
            rotate([90,90,0])
            cylinder(a/2,1.3,1.3);
            translate([15.425,0,gb/4-a/10-2.4])
            rotate([0,45,0])
            cube([gb+0.4,gb*2+0.4,gb/2.5],true);
            translate([-15.425,0,gb/4-a/10-2.4])
            rotate([0,-45,0])
            cube([gb+0.4,gb*2+0.4,gb/2.5],true);
        }
    }
    color("grey")
    translate([0,0,-a/2]){
        translate([a/8+2,0,gb/4-a/10-0.4])
        cube([a/4+a/10-0.1,gb*2-0.1,gb/2.5-0.1],true);
        translate([-a/8-1,0,gb/4-a/10-0.4-2.3])
        rotate([0,-20,0])
        cube([a/4+a/10-0.1,gb*2-0.1,gb/2.5-0.1],true);
        translate([0,a/4-0.2,-gb/2])
        rotate([90,90,0])
        cylinder(a/2-0.4,1,1);
        translate([-0.24,0,0])
        rotate([0,-20,0])
        intersection(){
        translate([-15.425,0,gb/4-a/10-2.4])
        rotate([0,-45,0])
        cube([gb,gb*2,gb/2.5],true);
        translate([-a/8-16,0,gb/4-a/10-0.4])
        cube([a/4+a/10-0.1,gb*2-0.1,gb/2.5-0.1],true);
        }
        translate([-0.1,0,0])
        rotate([180,180,0])
        intersection(){
        translate([-15.425,0,gb/4-a/10-2.4])
        rotate([0,-45,0])
        cube([gb,gb*2,gb/2.5],true);
        translate([-a/8-16,0,gb/4-a/10-0.4])
        cube([a/4+a/10-0.1,gb*2-0.1,gb/2.5-0.1],true);
        }
    }
    translate([a/2-2.5,a/2-2.5,-a/2])
    cylinder(2,1,1);
    translate([-a/2+2.5,a/2-2.5,-a/2])
    cylinder(2,1,1);
    translate([a/2-2.5,-a/2+2.5,-a/2])
    cylinder(2,1,1);
    translate([-a/2+2.5,-a/2+2.5,-a/2])
    cylinder(2,1,1);
    
}

module fidget_6(){
            color("CornflowerBlue")
    translate([-a/2+gb/6-gb*2,-0.1,a/2-a/10-0.1])
    difference(){
        rotate([0,0,90])
        cube([a-a/5,gb/3-0.2,a-a/5-0.2],true);
        union(){  
        cube([a/4,a/4,a/2+4],true);
        translate([a/80+0.1,0,0])
        cube([a/40,a/4+a/8,a/2+4],true);   
        }
    }color("grey")
    translate([-a/2+gb/6-gb*2+a/80+0.2,-0.1,a/2-a/10-0.1]){
        translate([-0.1,0,0])
    cube([a/40-0.4,a/4+a/8-0.4,a/20],true); 
        translate([-a/40+0.1-a/80,0,0])
      cube([a/20,a/4-0.4,a/20],true); }
    }
dziura_w_obudowie();
podstawka();
mocowanie_glowica(b);
translate([b/25,0,0])
glowica();
wino();
fidget_1();
fidget_2();
fidget_3();
fidget_4();
fidget_5();
fidget_6();